import { select, geoPath, geoMercator, zoom, event, scaleOrdinal, schemeCategory10, csv, json, geoCentroid, scaleSqrt, max, format } from 'd3';
//import { feature } from 'topojson';
import { loadAndProcessData } from './UTils';
import {sizeLengend} from './sizeLengend';

const svg = select('svg');
const g = svg.append('g').attr('transform', 'translate(-300,100)');
const width = +svg.attr('width');
const height = +svg.attr('height');
const projection = geoMercator();
const pathGenerator = geoPath().projection(projection);
const radiusUnknownValue = d => d.properties.Travel;
const colorScale = scaleOrdinal(schemeCategory10);
const str_title = 'xxxx plot';
const affectTypeText = 'Public Transit';

loadAndProcessData().then(china_map => {
/*
Promise.all([
		csv('test_csv.csv'),
		json('https://raw.githubusercontent.com/deldersveld/topojson/master/countries/china/china-provinces.json')
	]).then(([csvData, topoJSONdata]) => {
		const china_map = feature(topoJSONdata, topoJSONdata.objects.CHN_adm1);
  	const provinceName = csvData.reduce((accumulator, d) => {
    	accumulator[d.ID] = d;
      return accumulator;
    }, {});*/
  
  const sizeScale = scaleSqrt()
    .domain([0, 500])
  	.range([0, 20]);
  
  // const backgroundRect = svg.selectAll('rect')
  // 	.data([null]);
  // backgroundRect.enter().append('rect')
  // 	.merge(backgroundRect)
  // 		.attr('x', 0)
  // 		.attr('y', 0)
  // 		.attr('rx', 10)
  // 		.attr('width', 200)
  // 		.attr('height', 60)
  // 		.attr('fill', 'black')
  // 		.attr('opacity', 0.2);
  
  // svg.append('text')
  // 		.text(str_title)
  // 		.attr('class', 'title')
  // 		.attr('x', 20)
  // 		.attr('y', 40);
  
  svg.append('g')
		.attr('transform', `translate(20, 100)`)
  	.append('text')
  		.attr("font-size", "80px")
  		.text("B")
  		.attr('x', 10)
  		.attr('y', -30);
  
  svg.append('g')
		.attr('transform', `translate(850, 300)`)
		.call(sizeLengend, {
    	sizeScale,
  		spacing: 40,
  		textOffset: 20,
  		numTicks: 5,
  		circleFill: 'rgba(165,42,42,0.5)',
    	tickFormat: format(',')})
  	.append('text')
  		.text(affectTypeText)
  		.attr("font-size", "30px")
  		.attr('x', -90)
  		.attr('y', -30);
  
  projection
      .scale(600)
      .center([80, 30.0]);
  
  g.selectAll('path')
  	.data(china_map.features)
    .enter().append('path')
  		.attr('d', pathGenerator)
  		.attr('class', 'province')
  		.attr('fill', d => colorScale(d.properties.ID_1))
  	.append('title')
  		.text(d => d.properties.Province);
  
  g.selectAll('circle').data(china_map.features)
  	.enter()
    	.append('circle')
  			.attr('class', 'unknown-circle')
  			.attr('cx', d => projection(geoCentroid(d))[0])
  			.attr('cy', d => projection(geoCentroid(d))[1])
  			.attr('r', d => sizeScale(radiusUnknownValue(d)));
  
});